;******* Servo riadenie 1 *******

.nolist
.include "m8def.inc"
.list

.def temp = r16
.def servo = r17
.def prac_int = r1
.def merny = r20
.def horny = r21
.def usek = r23
rjmp main
;*** vektor preruenia pre preteenie taa/asovaa_0 ***
.org $009
rjmp tc0i
;*** obsluha preruenia T/C_0 ***
tc0i:
	in prac_int,SREG	;ulo stavov register
	cbi PORTC,1			;deaktivuj tlatka
	cbi PORTC,2
	sbis PINB,0x00
	sbi PORTC,1			;nastav vstup
; *** kontrola spodnej koncovej polohy ***
	in merny,ADCH
	cpi merny,0x10
	cbi PORTC,1
	in merny,ADCH
	cpi merny,0x0F
	cbi PORTC,1
	in merny,ADCH
	cpi merny,0x0E
	cbi PORTC,1
	in merny,ADCH
	cpi merny,0x0D
	cbi PORTC,1
	in merny,ADCH
	cpi merny,0x0C
	cbi PORTC,1
	in merny,ADCH
	cpi merny,0x0B
	cbi PORTC,1
	in merny,ADCH
	cpi merny,0x0A
	cbi PORTC,1
	in merny,ADCH
	cpi merny,0x09
	cbi PORTC,1
	in merny,ADCH
	cpi merny,0x08
	cbi PORTC,1
	in merny,ADCH
	cpi merny,0x07
	cbi PORTC,1
	in merny,ADCH
	cpi merny,0x06
	cbi PORTC,1
	in merny,ADCH
	cpi merny,0x05
	cbi PORTC,1
	in merny,ADCH
	cpi merny,0x04
	cbi PORTC,1
	in merny,ADCH

	sbis PINB,0x01		;testuj bit
	sbi PORTC,2
;*** kontrola vrchnej koncovej polohy ***
	in merny,ADCH
	cpi merny,0xEC
	cbi PORTC,2
	in merny,ADCH
	cpi merny,0xED
	cbi PORTC,2
	in merny,ADCH
	cpi merny,0xEE
	cbi PORTC,2
	in merny,ADCH
	cpi merny,0xEF
	cbi PORTC,2
	in merny,ADCH
	cpi merny,0xF0
	cbi PORTC,2
	in merny,ADCH
	cpi merny,0xF1
	cbi PORTC,2
	in merny,ADCH
	cpi merny,0xF2
	cbi PORTC,2
	in merny,ADCH
	cpi merny,0xF3
	cbi PORTC,2
	in merny,ADCH
	cpi merny,0xF4
	cbi PORTC,2
	in merny,ADCH
	cpi merny,0xF5
	cbi PORTC,2
	in merny,ADCH
	cpi merny,0xF6
	cbi PORTC,2
	in merny,ADCH
	cpi merny,0xF7
	cbi PORTC,2
	in merny,ADCH
	cpi merny,0xF8
	cbi PORTC,2
	in merny,ADCH
	cpi merny,0xF9
	cbi PORTC,2

	out SREG,prac_int	;obnov stavov register
	reti
;***hlavn program ***
main:
;*** inicializcia zsobnku ***
	ldi temp,LOW(RAMEND)
	out SPL,temp
	ldi temp,HIGH(RAMEND)
	out SPH,temp
;*** inicializcia portov ***
	clr temp
	out DDRB,temp			;port B ako vstupn
	dec temp
	ldi servo,0x7E
	out DDRC,servo			;port C ako vstupno/vstupn
	out PORTB,temp			;pull-up na port B
	out DDRD,temp
	nop						;synchronizcia
;*** inicializcia AD prevodnka
	ldi servo,0x00
	out ADCSR,servo
	ldi servo,0x20	;10 bitov presnos
	out ADMUX,servo	;ta len ADC0
	ldi servo,0x80
	out ACSR,servo
	ldi servo,0xE4	;AD bez preruenia
	out ADCSR,servo	;s preddelikou 16
;*** tart asovaa ***
	ldi temp,0x05
	out TCCR0,temp
;*** nastavenie taa na 10 ms ***
	ldi temp,0xB2
	out TCNT0,temp
;*** zdroj preruenia asovaa ***
	ldi temp,0x01
	out TIMSK,temp
;*** povolenie vetkch preruen ***
	sei

;***  ***
LOOP:
	ser r22
	rcall Meranie
	rjmp LOOP

Meranie:
	in horny,ADCH
	in merny,ADCH
	eor horny,r22
	out PORTD,horny
	rcall Cakaj
	ret

Cakaj:
	dec r18
	brne Cakaj
	dec r19
	brne Cakaj
	ret
